<script lang="ts" context="module">
  import { TJSDialog } from '@typhonjs-fvtt/runtime/svelte/application'
  import { SvelteComponent } from 'svelte'

  export function rollDialog(
    title: string,
    dialogComponent: SvelteComponent,
    props: Record<string, unknown>,
    localize: (key: string) => string,
    buttonLabel?: string
  ) {
    return TJSDialog.prompt(
      {
        title,
        draggable: true,
        minimizable: false,
        modal: true,
        content: {
          class: dialogComponent,
          props: {
            ...props,
            localize,
          },
        },
        label: buttonLabel !== undefined ? buttonLabel : localize('roll'),
        icon: '<i class="fas fa-dice-d20"></i>',
      },
      {
        minWidth: 500,
        width: undefined, // allows a higher width if the content is larger
      }
    )
  }
</script>

<script lang="ts">
  import { getContext } from 'svelte'

  export let title = ''
  export let dialogComponent
  export let buttonLabel = undefined
  const localize = getContext('localize')

  export function open() {
    rollDialog(title, dialogComponent, $$props, localize, buttonLabel)
  }
</script>
